//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "GraphicsHelp.h"
#include <math.h>
#include <stdlib.h>
#include "MathsHelp.h"
//may have to uncomment the next include dependent on BCB version. Try first without altering.
//#include <wingdi.h>

//---------------------------------------------------------------------------
rgb __fastcall ExtractRGB(TColor colour)
{
    rgb result;
	/*int c1 = (int) colour;
	result.B = c1 >> 16;
    c1 = c1 - (result.B << 16);
    result.G = c1 >> 8;
    c1 = c1 - (result.G << 8);
	result.R = c1;*/
	result.R = (int) GetRValue((DWORD)(colour));
	result.G = (int) GetGValue((DWORD)(colour));
	result.B = (int) GetBValue((DWORD)(colour));

    return result;
}
//---------------------------------------------------------------------------

rgbcomponents __fastcall ExtractRGBcomponents(TColor colour)
{
    rgbcomponents finalresult;

    rgb result;
    int c1 = (int) colour;
    result.B = c1 >> 16;
    c1 = c1 - (result.B << 16);
    result.G = c1 >> 8;
    c1 = c1 - (result.G << 8);
    result.R = c1;

    finalresult.R  =  ((double)(result.R))/255.0;
    finalresult.G  =  ((double)(result.G))/255.0;
    finalresult.B  =  ((double)(result.B))/255.0;

    return finalresult;
}
//---------------------------------------------------------------------------


TColor __fastcall GetColourFromRGB(rgb Value)
{
    TColor result;

    if (Value.R < 0) Value.R = 0;
    if (Value.G < 0) Value.G = 0;
    if (Value.B < 0) Value.B = 0;
    if (Value.R > 255) Value.R = 255;
    if (Value.G > 255) Value.G = 255;
    if (Value.B > 255) Value.B = 255;

    //result = (TColor)(Value.R + Value.G * 256 + Value.B * 256 * 256);
    result = (TColor)(Value.R + (Value.G << 8) + (Value.B << 16));

    return result;
}
//---------------------------------------------------------------------------

redgreenblue __fastcall ExtractRedGreenBlue(TColor colour)
{
    redgreenblue result;
    double c1 = (double) colour;
    result.B = floor(c1/(256.0 * 256.0));
    c1 = c1 - (result.B * 256.0 * 256.0);
    result.G = floor(c1/256.0);
    c1 = c1 - (result.G * 256.0);
    result.R = c1;

    return result;
}
//---------------------------------------------------------------------------

TColor __fastcall GetColourFromRedGreenBlue(redgreenblue Value)
{
    TColor result;

    if (Value.R < 0.0) Value.R = 0.0;
    if (Value.G < 0.0) Value.G = 0.0;
    if (Value.B < 0.0) Value.B = 0.0;

    result = (TColor)((int)Value.R + ((int)Value.G) * 256 + ((int)Value.B) * 256 * 256);

    return result;
}
//---------------------------------------------------------------------------

hsb __fastcall RGBtoHSB(rgb Value)
{
    //converts RGB to Hue, Saturation, Brightness
    hsb result;

    double minRGB, maxRGB, Delta;
    double h, s, b;
    h = 0.0;
	//minRGB = (double)(min(min(Value.R,Value.G),Value.B));
	//maxRGB = (double)(max(max(Value.R,Value.G),Value.B));
	minRGB = Value.R;
	if (minRGB > Value.G) minRGB = Value.G;
	if (minRGB > Value.B) minRGB = Value.B;

	maxRGB = Value.R;
	if (maxRGB < Value.G) maxRGB = Value.G;
	if (maxRGB < Value.B) maxRGB = Value.B;

	Delta = maxRGB - minRGB;
    b = maxRGB;
    if (maxRGB != 0.0) {
        s = 255.0 * Delta /maxRGB;
        } else {
        s = 0.0;
        }
    if (s != 0.0) {
        if (((double) Value.R) == maxRGB) {
            h = ((double)(Value.G - Value.B))/Delta;
            } else {
            if (((double) Value.G) == maxRGB) {
                h = 2.0 + ((double)(Value.B - Value.R))/Delta;
                } else {
                if (((double) Value.B) == maxRGB) {
                    h = 4.0 + ((double)(Value.R - Value.G))/Delta;
                    }
                }
            }
        } else {
        h = -1.0;
        }
    h = h * 60.0;
    if (h < 360.0) h = h + 360.0;
    result.Hue = h;
    result.Saturation = s / 255.0;
    result.Brightness = b / 255.0;

    return result;
}
//---------------------------------------------------------------------------

rgb __fastcall HSBtoRGB(hsb Value)
{
    //converts Hue, Saturation, Brightness to RGB
    rgb result;

    double maxRGB, Delta;
    double h, s, b;

    h = Value.Hue / 60.0;
    s = Value.Saturation * 255.0;
    b = Value.Brightness * 255.0;
    maxRGB = b;

    if (s == 0.0) {
        result.R = 0;
        result.G = 0;
        result.B = 0;
        } else {
        Delta = s * maxRGB / 255.0;
        if (h > 3.0) {
            result.B = (int)(ROUND(maxRGB,0));
            if ( h > 4.0) {
                result.G = (int)(ROUND(maxRGB - Delta,0));
                result.R = ((int)(ROUND((h - 4.0) * Delta,0))) + result.G ;
                } else {
                result.R = (int)(ROUND(maxRGB - Delta,0));
                result.G = result.R - ((int)(ROUND((h - 4.0) * Delta,0)));
                }
            } else {
            if (h > 1.0) {
                result.G = (int)(ROUND(maxRGB,0));
                if (h > 2.0) {
                    result.R = (int)(ROUND(maxRGB - Delta,0));
                    result.B = ((int)(ROUND((h - 2.0) * Delta,0))) + result.R ;
                    } else {
                    result.B = (int)(ROUND(maxRGB - Delta,0));
                    result.R = result.B - ((int)(ROUND((h - 2.0) * Delta,0)));
                    }
                } else {
                if (h > -1.0) {
                    result.R = (int)(ROUND(maxRGB,0));
                    if (h > 0.0) {
                        result.B = (int)(ROUND(maxRGB - Delta,0));
                        result.G = ((int)(ROUND((h - 2.0) * Delta,0))) + result.B ;
                        } else {
                        result.G = (int)(ROUND(maxRGB - Delta,0));
                        result.B = result.G - ((int)(ROUND(h * Delta,0)));
                        }
                    }
                }
            }
        }

    return result;

}
//---------------------------------------------------------------------------

TColor __fastcall InvertColour(TColor colour)
{
    rgb intermediate = ExtractRGB(colour);
    intermediate.R = 255 - intermediate.R;
    intermediate.G = 255 - intermediate.G;
    intermediate.B = 255 - intermediate.B;

    return GetColourFromRGB(intermediate);
}
//---------------------------------------------------------------------------

TColor __fastcall InvertRG(TColor colour)
{
    //only inverts the Red & Green Components
    rgb intermediate = ExtractRGB(colour);
    intermediate.R = 255 - intermediate.R;
    intermediate.G = 255 - intermediate.G;

    return GetColourFromRGB(intermediate);
}
//---------------------------------------------------------------------------


redgreenblue __fastcall RGBtoRedGreenBlue(rgb value)
{
    redgreenblue result;

    result.R = (double) value.R;
    result.G = (double) value.G;
    result.B = (double) value.B;

    return result;
}
//---------------------------------------------------------------------------

rgb __fastcall RedGreenBluetoRGB(redgreenblue value)
{
    rgb result;

    result.R = (int) value.R;
    result.G = (int) value.G;
    result.B = (int) value.B;

    return result;
}
//---------------------------------------------------------------------------

redgreenblue __fastcall ScaleRedGreenBlue(redgreenblue value,double scalefactor)
{
    redgreenblue result;

    result.R = value.R * scalefactor;
    result.G = value.B * scalefactor;
    result.B = value.G * scalefactor;

    return result;

}
//---------------------------------------------------------------------------

redgreenblue __fastcall AddRedGreenBlue(redgreenblue value1,redgreenblue value2)
{
    redgreenblue result;

    result.R = value1.R + value2.R;
    result.G = value1.G + value2.G;
    result.B = value1.B + value2.B;

    return result;

}
//---------------------------------------------------------------------------

rgb __fastcall MeanRGB(rgb Value1, rgb Value2)
{
    rgb result;

    result.R = (Value1.R + Value2.R)/2;
    result.G = (Value1.G + Value2.G)/2;
    result.B = (Value1.B + Value2.B)/2;

    return result;
}
//---------------------------------------------------------------------------

rgb __fastcall AddRGB(rgb Value1, rgb Value2)
{
    rgb result;

    result.R = Value1.R + Value2.R;
    result.G = Value1.G + Value2.G;
    result.B = Value1.B + Value2.B;

    return result;
}
//---------------------------------------------------------------------------

rgb __fastcall SubtractRGB(rgb Value1, rgb Value2)
{
    rgb result;

    result.R = Value1.R - Value2.R;
    result.G = Value1.G - Value2.G;
    result.B = Value1.B - Value2.B;

    return result;
}
//---------------------------------------------------------------------------

rgb __fastcall MultiplyRGB(rgb Value, int scalefactor)
{
    rgb result;

    result.R = Value.R * scalefactor;
    result.G = Value.G * scalefactor;
    result.B = Value.B * scalefactor;

    return result;
}
//---------------------------------------------------------------------------
 
rgb __fastcall DivideRGB(rgb Value, int scalefactor)
{
    rgb result;

    result.R = Value.R / scalefactor;
    result.G = Value.G / scalefactor;
    result.B = Value.B / scalefactor;

    return result;
}
//---------------------------------------------------------------------------

AnsiString __fastcall ColourString(TColor colour)
{
    rgb result;
    int c1 = (int) colour;
    result.B = c1 >> 16;
    c1 = c1 - (result.B << 16);
    result.G = c1 >> 8;
    c1 = c1 - (result.G << 8);
    result.R = c1;
    if (result.R == 0) result.R = 1;
    if (result.G == 0) result.G = 1;
    if (result.B == 0) result.B = 1;

    AnsiString text;

    text = AnsiString(((char)(result.R))) + AnsiString(((char)(result.G)))+ AnsiString(((char)(result.B)));

    return text;
}
//---------------------------------------------------------------------------

