//---------------------------------------------------------------------------
#ifndef GraphicsHelpH
#define GraphicsHelpH
//may have to change the next include dependent on BCB version
#include <Graphics.hpp>
//---------------------------------------------------------------------------
//normal usage
typedef struct {
    int R,G,B;
    } rgb;

//sometimes useful, will take longer
typedef struct {
    double R,G,B;
    } redgreenblue;

typedef struct {
    //Ranges    Hue        0.0 to 360.0 degrees(full circle),
    //          Saturation 0.0 to   1.0
    //          Brightness 0.0 to   1.0
    double Hue, Saturation, Brightness;
    } hsb;

typedef struct {
    //Ranges    Red        0.0 to   1.0
    //          Green      0.0 to   1.0
    //          Blue       0.0 to   1.0
    double R, G, B;
    } rgbcomponents;

rgb __fastcall ExtractRGB(TColor colour);
rgbcomponents __fastcall ExtractRGBcomponents(TColor colour);
TColor __fastcall GetColourFromRGB(rgb Value);
redgreenblue __fastcall ExtractRedGreenBlue(TColor colour);
TColor __fastcall GetColourFromRedGreenBlue(redgreenblue Value);
hsb __fastcall RGBtoHSB(rgb Value);
rgb __fastcall HSBtoRGB(hsb Value);
TColor __fastcall InvertColour(TColor colour);
TColor __fastcall InvertRG(TColor colour);

redgreenblue __fastcall RGBtoRedGreenBlue(rgb value);
rgb __fastcall RedGreenBluetoRGB(redgreenblue value);
redgreenblue __fastcall ScaleRedGreenBlue(redgreenblue value,double scalefactor);
redgreenblue __fastcall AddRedGreenBlue(redgreenblue value1,redgreenblue value2);

rgb __fastcall MeanRGB(rgb Value1, rgb Value2);
rgb __fastcall AddRGB(rgb Value1, rgb Value2);
rgb __fastcall SubtractRGB(rgb Value1, rgb Value2);
rgb __fastcall MultiplyRGB(rgb Value, int scalefactor);
rgb __fastcall DivideRGB(rgb Value, int scalefactor);


AnsiString __fastcall ColourString(TColor colour);



#endif
