//---------------------------------------------------------------------------

#ifndef PageSizeHelpH
#define PageSizeHelpH
//may have to change the next include dependent on BCB version
#include <System.Types.hpp>

//---------------------------------------------------------------------------

//structures etc unique to the PageSizeHelp unit
//must not change these enums now, only add to them if need be
//enum value for object tag   0           1             2      3      4      5      6      7        8               9         10       11       12       13         14             15     16     17     18     19     20     21     22        23        24        25       26        27                      28          29              30              31                  32              33             34           35                    36                         37                       38                     39                    40                  41               42                     43
enum TPageSize               {psA0      , psA1        , psA2 , psA3 , psA4 , psA5 , psA6 , psLegal, psJuniorLegal , psANSIE , psANSID, psANSIC, psANSIB, psLetter , psHalfLetter , psB0 , psB1 , psB2 , psB3 , psB4 , psB5 , psB6 , psArchE , psArchD , psArchC , psArchB, psArchA , psCustom } ;
enum TPageDirection          {pdPortrait, pdLandscape };

typedef struct {
	TPageSize PageSize;
	TPageDirection PaperDirection;
	double PageWidth, PageHeight;
    int dpi;
	} pagesize;

typedef struct {
	double LeftMargin,TopMargin,RightMargin,BottomMargin;
	} pagemargin;

//Sizes in millimetres
//always returns a portrait page
pagesize __fastcall GetPageSize(TPageSize Size);
//can return a landscape
pagesize __fastcall GetPageSize(TPageSize Size, TPageDirection Direction);
//returns the sizes specified in the orientation specified
pagesize __fastcall GetLandscapePage(TPageSize Size);
pagesize __fastcall GetPortraitPage(TPageSize Size);

//returns the most likely page size based on the supplied dimensions
pagesize __fastcall WhatPageIsThis(double Width, double Height);
//returns an ansistring of the name of the page, eg "A4"
AnsiString __fastcall PageName(TPageSize PageSize);
#endif
